#!/bin/bash
set -e
TestCase=$1
CUDA_PATH=$2
HeteroMark_PATH=$3
CuPBoP_BUILD_PATH=$4
DATASET_PATH=$5
if [ ! -d $DATASET_PATH ]; then
    echo "Download Hetero Mark dataset"
    mkdir $DATASET_PATH
    cd $DATASET_PATH
    wget https://www.dropbox.com/s/ie2hcxw9lfoghg8/data.tar.gz?dl=1
    tar -xzf 'data.tar.gz?dl=1'
    mv data/* .
fi

mkdir -p $TestCase
cd $TestCase
clang++ -std=c++11 $HeteroMark_PATH/src/$1/cuda/$1_cuda_benchmark.cu -I$HeteroMark_PATH \
        --cuda-path=$CUDA_PATH  \
        --cuda-gpu-arch=sm_50 -L$CUDA_PATH/lib64 \
        -lcudart_static -ldl -lrt -pthread -save-temps

# clang++ -std=c++11 vecadd.cu \
#       -I../.. --cuda-path=$CUDA_PATH \
#       --cuda-gpu-arch=sm_50 -L$CUDA_PATH/lib64 \
#       -lcudart_static -ldl -lrt -pthread -save-temps -v

